var alarmDisplayWidget = StudioWidgetWrapper.extend(
{
    /*
     * Triggered when initializing a widget and will have the code that invokes rendering of the widget
     * setParentContainer(JQueryParentContainerDOM) - binds event to this container
     * setItemContainer(JQueryItemContainerDOM) - binds studio item events for respective item containers
     * bindEvents() - binds the studio event to this widget
     */
    init: function()
    {
        var thisObj = this;
        thisObj._super.apply(thisObj, arguments);
        thisObj.render();
        if ((typeof(Studio) != "undefined") && Studio)
        {	
           
        }
    },

    /*
     * Triggered from init method and is used to render the widget
     */
    render: function()
    {
        var thisObj = this;
        var widgetProperties = thisObj.getProperties();
        var elem = thisObj.getContainer();
        var items = thisObj.getItems();
        var connectorProperties = thisObj.getConnectorProperties();

        /*
         * API to get base path of your uploaded widget API file
         */
        var widgetBasePath = thisObj.getWidgetBasePath();
        if (elem)
        {
            var containerDiv = $(".scfClientRenderedContainer", elem);
            if (containerDiv.length)
            {
                $(containerDiv).empty();
            }
            else
            {
                containerDiv = document.createElement('div');
                containerDiv.className = "scfClientRenderedContainer";
                $(elem).append(containerDiv);
            }

var vm = new Vue({
    el: $("#widgetVueTemplate",elem)[0],
    data:{
        listData: [
            {
                "title": "设备告警",
                "content": "设备A1 CPU使用率过高",
                "date": "2020-12-09 09:15:09"
            },
            {
                "title": "车辆告警",
                "content": "车辆-XXXXXXX 未登记",
                "date": "2020-12-10 15:09:20"
            }
            ],
            ws: null      
    },
    mounted: function () {
                this.init();
    },
    methods: {
        init: function() {
            //获取WebSocket订阅地址
            let urlMessage = "tenantId="+ $.cookie("tenant-id") + "&event=CNAME1__WebSocketAlarmEvent__e";
            let url = `wss:///${location.host}/websocket/v1.0/component/listener?${urlMessage}`;
 
            //打开一个WebSocket
            this.ws = new WebSocket(url);
            //WebSocket连接建立时触发事件
            this.ws.onopen = event => {
                this.ws.send("");
                console.log("WebSocket has connected.");
            };
            //WebSocket连接关闭时触发事件
            this.ws.onclose = event => {                        
                console.log("WebSocket has closed.");
            
            };
            //WebSocket通信错误时触发事件
            this.ws.onerror = event => {
                console.log("WebSocket has error.");                        
            };
            //WebSocket客户端接受服务端数据时触发事件
            this.ws.onmessage = event => {
                if (event.data) {
                    let dataObj = JSON.parse(event.data);
                    if (dataObj.content) {
                        let data = JSON.parse(dataObj.content);   
                        if (data.payload) {
                            let content = JSON.parse(data.payload);    
                            this.listData.push( {
                                "title": content.AlarmTitle,
                                "content": content.AlarmContent,
                                "date": content.AlarmDate,
                            });
                        }
                    }         
                }                            
            };
            this.intervalID = setInterval(() => {
                this.ws.send("");
            }, 50000);
        },                 
    },
    destroyed() {
        if (this.ws) {
            this.ws.close();
        }
    }
});
        }

        /*
         * API to refresh the previously bound events when a resize or orientation change occurs.
         *  thisObj.sksRefreshEvents(ItemIdx);
         * ItemIdx (Optional) - To refresh events for a specific item. Default value is 0.
         */
        $(window).resize(function()
        {
            thisObj.sksRefreshEvents();
        });
    }
});